PAGE 66,132
TITLE main.asm: semplice programma assembly 8086

COMMENT *
Semplice programma che fa uso dell'interrupt 21H del DOS
per fare output su video.  Prima di uscire, il programma
restituisce il controllo al DOS. Vengono creati 3 segmenti,
viene fatta una chiamata a subroutine, si fa uso di macro
e vengono usate diverse direttive ed istruzioni.
*

;-----------------------------------------------------------------
; Interfaccia con l'esterno
.SALL                          ; soppressione espansione macro nel testo
IF1                            ; l'inclusione delle macro avviene
INCLUDE DOSINT.MCR             ; nel primo passo dell'assemblaggio
ENDIF
EXTRN SUBROUT: FAR

;-----------------------------------------------------------------
; Definizione costanti
CR EQU 13                      ; carriage return
LF EQU 10                      ; line feed

;-----------------------------------------------------------------
;
STACK SEGMENT STACK 'STACK'    ; definizione del segmento di stack
      DB      64 DUP('STACK')  ; lo stack e' riempito con la stringa 'stack'
                               ; per identificarlo meglio in fase di debug
TOS   LABEL WORD               ; identifica il top of stack
STACK ENDS                     ;

;-----------------------------------------------------------------
;
DATA SEGMENT PUBLIC 'DATA'     ; definizione segmento dati

SALVE DB CR,LF,LF
      DB 'Ciao, sono MAIN...',5 dup(' '),LF,'$'
CIAO  DB 'Ciao, sono ancora MAIN' ; alla variabile CIAO e' associato
      DB LF,'$'                   ; l'offset del primo carattere della stringa

DATA ENDS

;-----------------------------------------------------------------
;
CSEG SEGMENT PUBLIC 'CODE'

MAIN PROC FAR
      ASSUME CS:CSEG,DS:DATA,SS:STACK,ES:NOTHING;

        PUSH DS               ; salvataggio valore corrente di DS
        SUB AX,AX             ; AX viene azzerato, e
        PUSH AX               ; posto nello stack
                              ; Quando con la RET si restituisce il
                              ; controllo al DOS, questo riparte da DS:0000.
                              ; La RET effettua automaticamente il POP
                              ; dei due registri

        MOV AX,DATA           ; necessari 2 trasferimenti per assegnare a DS
        MOV DS,AX             ; l'indirizzo del segmento dati in modo esplicito


VISUAL: DISPLAY SALVE         ; display della stringa di esordio (DS:DX)

        CALL SUBROUT          ; chiamata a subroutine

        DISPLAY CIAO          ; display messaggio di saluto finale

        RET                   ; si restituisce il controllo al DOS

MAIN ENDP

CSEG ENDS

END MAIN                     ; il programma comincia all'indirizzo di MAIN
